#include <GL/osmesa.h>
#include "alldessiner.h"

extern void Draw();
void InitGL()
{
    int i ;
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_COLOR_MATERIAL);
    glEnable(GL_LIGHTING);

/*
    for (i = 0 ; i < 8 ; i++)
        glEnable(GL_LIGHT0 + i);
*/
        glEnable(GL_LIGHT0);
}


void Reshape (int w, int h)
{
   glViewport     (0, 0, w, h);
   glMatrixMode   (GL_PROJECTION);
   glLoadIdentity ( );

   if ( h==0 )
      gluPerspective ( 80, ( float ) w, 1.0, 5000.0 );
   else
      gluPerspective ( 80, ( float ) w / ( float ) h, 1.0, 5000.0 );
   glMatrixMode   (GL_MODELVIEW);
   glLoadIdentity ();
}

OSMesaContext OSContext;
char *framebuffer;

void myGlInit(int width, int height)
{
  OSContext = OSMesaCreateContext(GL_RGBA,NULL);
  /*Allocating your frame buffer based on width and height the you choose */
  framebuffer=(char *)malloc(width*height*sizeof (int)); /* for a 512x512 pixel rendering
                                            surface */
  OSMesaMakeCurrent(OSContext,framebuffer,GL_UNSIGNED_BYTE,width, height);
} /* myGlInit */

void Draw_scene ()
{
   Draw () ;
   glutPostRedisplay () ;
   glutSwapBuffers () ;
}

void start_animation (int ecran, int nbimage)
{
    if (ecran)
    {
	glutInitWindowSize(200,200);
	glutCreateWindow("AllDessiner");

        InitGL () ;
        glutReshapeFunc (Reshape);
        glutDisplayFunc (Draw_scene);
        glutMainLoop ();
    }
    else
    {
        myGlInit (200, 200) ;
        InitGL () ;
        Reshape (200, 200) ;
        glPixelStorei(GL_PACK_ALIGNMENT,1);
        glPixelStorei(GL_PACK_SWAP_BYTES, 1);

        save_sequence (nbimage) ;
    }
}


void save_sequence (int nbimage)
{
    char image_filename [255] ;
    int i ;

    for (i = 0 ; i < nbimage ; i++)
    {
        sprintf (image_filename, "%s%04d.ppm", "Photo", i) ;
//        clock = (double)i * 1 / (frames_count - 1);
//        printf ("Generation de image %4d / %4d, clock = %f", i + 1, nbimage,clock) ;
        fflush (stdout) ;
        Draw () ;
        save_image (image_filename) ;
   }
}

void save_image (char *filename)
{
    FILE *file ;
    int *pixels ;
    int r, g, b, i, j ;
    int *pixel ;
    char str [255] ;
    int pixels_count ;

    pixels_count = 200 * 200 ;

    pixels = (int *)malloc (sizeof (int) * pixels_count) ;
    if (pixels == NULL)
    {
        perror ("Can not allocate pixels") ;
        exit (1) ;
    }

    glReadPixels (0, 0, 200, 200, GL_RGBA, GL_UNSIGNED_BYTE, pixels);

    file = fopen (filename, "w") ;
    if (file == NULL)
    {
        sprintf (str, "Can not open file %s", filename) ;
        perror (str) ;
        exit (1) ;
    }

    fputs ("P3\n", file);
    fprintf (file, "%d %d\n", 200, 200);
    fputs ("255 ", file);

    for (i = 200 - 1 ; i >= 0 ; i--)
    {
        pixel = pixels + i * 200 ;
        for (j = 0 ; j < 200 ; j++)
        {
            if (!((i * 200 + j) % 5))
                fputs("\n", file);

            r = *pixel         & 0xff;
            g = (*pixel >> 8)  & 0xff;
            b = (*pixel >> 16) & 0xff;
            pixel++ ;
            fprintf(file, " %03d %03d %03d ", r, g, b);
        }
    }
    free ((int *)pixels) ;
    fclose (file) ;
}
