#include "objet.h"

void affichelumiere (float *falloff, float *LightSrc, int *LightPos, int *LightDir, int nlights)
{
  float LightDiff[4] = {.5f,.5f,1.f,1.f};
  int Light[4];
  int dx,dy,dz;
  double norme;
  float direct[4]; 
  
  LightPos[3] = 1;
  
  dx = LightDir[0] - LightPos[0];
  dy = LightDir[1] - LightPos[1];
  dz = LightDir[2] - LightPos[2];
  
  norme = sqrt(dx*dx+dy*dy+dz*dz);
  direct[0] = (float) dx /norme;
  direct[1] = (float)  dy /norme;
  direct[2] = (float) dz /norme;
  direct[3] = 0;
  
  
  //ajout d'une couleur a la lumiere
  
  // Position de la lumiere
  glLightiv(GL_LIGHT0 + nlights, GL_POSITION, LightPos);
  
  // Direction du spot
  glLightfv(GL_LIGHT0 + nlights, GL_SPOT_DIRECTION,direct );

  glLightfv(GL_LIGHT0 + nlights,GL_DIFFUSE,LightDiff);  
  glLightfv (GL_LIGHT0 + nlights,GL_DIFFUSE, LightSrc);
  glLightfv(GL_LIGHT0 + nlights, GL_SPECULAR, LightSrc);  
  glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SINGLE_COLOR);
  glLightfv (GL_LIGHT0 + nlights, GL_SPOT_CUTOFF, falloff) ;
}


void afficheBox(point3d a, point3d b)
{
  double dx,dy,dz;
  
  glPushMatrix();
  if (a.x < b.x)
    dx =a.x + (double) abs(a.x - b.x)/2;
  else
    dx =b.x + (double) abs(a.x - b.x)/2;
  
  if (a.y < b.y)
    dy =a.y +  (double) abs(a.y - b.y)/2;
  else
    dy =b.y + (double) abs(a.y - b.y)/2;
  
  if (a.z < b.z)
    dz =a.z + (double) abs(a.z - b.z)/2;
  else
    dz =b.z +  (double) abs(a.z - b.z)/2;
  
  glScaled((double)abs(a.x - b.x), (double)abs(a.y - b.y), (double)abs(a.z - b.z));
  glTranslated(dx,dy ,dz);
  
  glutSolidCube(1);
  
  glPopMatrix(); 
  
} 

void affichePlan(point3d axe, couleur c1, couleur c2)
{
  
  int square[16][3];
  int i, j;
  int axe1, axe2,axe3;
  int coor;
  if (axe.x != 0)
    {
      axe1 = 2;
      axe2 = 1;
      axe3 = 0;
      coor = axe.x;
    }
  else
    if (axe.y != 0)
      {
	axe1 = 0;
	axe2 = 2;
	axe3 = 1;		
	coor = axe.y;
      }
    else
      if (axe.z != 0)
	{
	  axe1 = 1;
	  axe2 = 0;
	  axe3 = 2;
	  coor = axe.z;
	}
  
  
  for (j = 0; j < 100; j++) 
    {
      for (i = 0; i < 100; i++) 
	{
	  square[0][axe1] = -100 + 200 / 100 * i;
	  square[0][axe2] = -100 + 200 / 100 * (j + 1);
	  square[0][axe3] = coor;
	  
	  square[1][axe1] = -100 + 200 / 100 * i;
	  square[1][axe2] = -100 + 200 / 100 * j;
	  square[1][axe3] = coor;
	  
	  square[2][axe1] = -100 + 200 / 100 * (i + 1);
	  square[2][axe2] = -100 + 200 / 100 * j;
	  square[2][axe3] = coor;
	  
	  
	  square[3][axe1] = -100 + 200 / 100 * (i + 1);
	  square[3][axe2] = -100 + 200 / 100 * (j + 1);
	  square[3][axe3] = coor;
	  
	  if ((i+j)%2 == 0)
	    {
	      glBegin(GL_QUADS); 
	      glColor3i(c1.r,c1.v,c1.b);
	      glVertex3iv(&square[0][0]);
	      glVertex3iv(&square[1][0]);
	      glVertex3iv(&square[2][0]);
	      glVertex3iv(&square[3][0]);
	      glEnd();			
	      
	    } 
	  else 
	    {
	      glBegin(GL_QUADS); 
	      glColor3d(c2.r,c2.v,c2.b);
	      glVertex3iv(&square[0][0]);
	      glVertex3iv(&square[1][0]);
	      glVertex3iv(&square[2][0]);
	      glVertex3iv(&square[3][0]);
	      glEnd();			
	      
	    }
	}
    }
}

void afficheSphere(point3d centre, int rayon, couleur c)
{
  glTranslated(centre.x,centre.y,centre.z);
  glutSolidSphere(rayon,30,30);
}

void afficheCylinder (double rayon, point3d top_location, point3d base_location)
{
  double hauteur ;
  double vx, vy, vz ;
  GLUquadricObj *qobj = gluNewQuadric ();
  
  double top_x, top_y, top_z ;
  double base_x, base_y, base_z ;
  
  double axe_x, axe_y, axe_z ;
  
  gluQuadricTexture(qobj, GL_TRUE) ;
  
  top_x = top_location.x;
  top_y = top_location.y;
  top_z = top_location.z;
  
  base_x = base_location.x;
  base_y = base_location.y;
  base_z = base_location.z;
  
  vx = top_x - base_x ;
  vy = top_y - base_y ;
  vz = top_z - base_z ;
  
  hauteur = sqrt (vx * vx + vy * vy + vz * vz) ;
  
  axe_x = (top_x - base_x) / 2 ;
  axe_y = (top_y - base_y) / 2 ;
  axe_z = (top_z - base_z + hauteur) / 2 ;
  
  glTranslatef (base_x, base_y, base_z) ;
  glRotatef (180, axe_x, axe_y, axe_z) ;
    
  gluCylinder (qobj, rayon, rayon, hauteur, 20, 20) ;
  
  gluQuadricOrientation (qobj, GLU_INSIDE) ;
  gluDisk (qobj, 0, rayon, 20, 20) ;
  
  glTranslatef (0, 0, hauteur) ;
  gluQuadricOrientation (qobj, GLU_OUTSIDE) ;
  gluDisk (qobj, 0, rayon, 20, 20) ;
  
  gluDeleteQuadric (qobj);
}


void afficheCone (point3d base, point3d top, double base_rayon, double top_rayon)
{
  double hauteur ;
  double vx, vy, vz ;
  GLUquadricObj *qobj = gluNewQuadric ();
  
  double top_x, top_y, top_z ;
  double base_x, base_y, base_z ;
  
  double axe_x, axe_y, axe_z ;
  
  gluQuadricTexture(qobj, GL_TRUE) ;
  gluQuadricNormals(qobj, GLU_SMOOTH) ;
  
  top_x = top.x ;
  top_y = top.y ;
  top_z = top.z ;
  
  base_x = base.x;
  base_y = base.y;
  base_z = base.z;
  
  vx = top_x - base_x ;
  vy = top_y - base_y ;
  vz = top_z - base_z ;
  
  hauteur = sqrt (vx * vx + vy * vy + vz * vz) ;
  
  axe_x = (top_x - base_x) / 2 ;
  axe_y = (top_y - base_y) / 2 ;
  axe_z = (top_z - base_z + hauteur) / 2 ;
  
  glTranslatef (base_x, base_y, base_z) ;
  glRotatef (180, axe_x, axe_y, axe_z) ;
  
  gluCylinder (qobj, base_rayon, top_rayon,
	       hauteur, 20, 20) ;
  
  gluQuadricOrientation (qobj, GLU_INSIDE) ;
  gluDisk (qobj, 0, base_rayon, 20, 20) ;
  
  glTranslatef (0, 0, hauteur) ;
  gluQuadricOrientation (qobj, GLU_OUTSIDE) ;
  gluDisk (qobj, 0, top_rayon, 20, 20) ;
  
  gluDeleteQuadric (qobj);
}

